﻿/// <reference path="data.js" />

(function (lightSwitchApplication) {

    var $Screen = msls.Screen,
        $defineScreen = msls._defineScreen,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString,
        $defineShowScreen = msls._defineShowScreen;

    function AddEditTable1Item(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditTable1Item screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Table1Item" type="msls.application.Table1Item">
        /// Gets or sets the table1Item for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditTable1Item.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditTable1Item", parameters);
    }

    function ViewTable1Item(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the ViewTable1Item screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Table1Item" type="msls.application.Table1Item">
        /// Gets or sets the table1Item for this screen.
        /// </field>
        /// <field name="details" type="msls.application.ViewTable1Item.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "ViewTable1Item", parameters);
    }

    function BrowseTable1Items(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseTable1Items screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Table1Items" type="msls.VisualCollection" elementType="msls.application.Table1Item">
        /// Gets the table1Items for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseTable1Items.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseTable1Items", parameters);
    }

    msls._addToNamespace("msls.application", {

        AddEditTable1Item: $defineScreen(AddEditTable1Item, [
            { name: "Table1Item", kind: "local", type: lightSwitchApplication.Table1Item }
        ], [
        ]),

        ViewTable1Item: $defineScreen(ViewTable1Item, [
            { name: "Table1Item", kind: "local", type: lightSwitchApplication.Table1Item }
        ], [
        ]),

        BrowseTable1Items: $defineScreen(BrowseTable1Items, [
            {
                name: "Table1Items", kind: "collection", elementType: lightSwitchApplication.Table1Item,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Table1Items;
                }
            }
        ], [
        ]),

        showAddEditTable1Item: $defineShowScreen(function showAddEditTable1Item(Table1Item, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditTable1Item screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditTable1Item", parameters, options);
        }),

        showViewTable1Item: $defineShowScreen(function showViewTable1Item(Table1Item, options) {
            /// <summary>
            /// Asynchronously navigates forward to the ViewTable1Item screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("ViewTable1Item", parameters, options);
        }),

        showBrowseTable1Items: $defineShowScreen(function showBrowseTable1Items(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseTable1Items screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseTable1Items", parameters, options);
        })

    });

}(msls.application));
